#include <bits/stdc++.h>

using namespace std;
int h,n,a,l/*pozicija levog keca*/,zn/*zbir nula*/;
vector<int> mat[1000003];
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> h >> n;
    for(int i = 0; i < n; i++)
        mat[0].push_back(1);
    for(int i = 1; i <= h; i++){
        for(int j = 1; j <= n; j++){
            cin >> a;
            mat[i].push_back(a);
        }
    }
    for(int i = 1; i <= h; i++){
        zn = 0;
        l = -1;
        for(int j = 0; j < n; j++){

            if(mat[i][j] == 1){//polje sa 1

                mat[i][j] = mat[i-1][j];

                if(zn != 0){
                    if(l == -1)
                        mat[i][j] += zn;
                    else{
                        mat[i][l] += zn/2;
                        mat[i][j] += zn/2;
                        if(zn % 2 == 1){
                            if(i % 2 == 1)
                                mat[i][l]++;
                            else
                                mat[i][j]++;
                        }

                    }
                    zn = 0;
                }
                l = -1;
                if(j+1 < n && mat[i][j+1] == 0)
                    l = j;

            }

            else{ // polje sa 0
                zn += mat[i-1][j];
            }
        }
        if(zn != 0){
            mat[i][l] += zn;
        }
    }

    for(int i = 0; i < n; i++){
        cout << mat[h][i] << " ";
    }
    return 0;
}